/*
 * Intel PRO/1000 T IP Storage Adapter constructs and constants definitions
 * Copyright (C) 2002 Wind River Systems
 * Copyright (C) 2003 Intel Corporation
 *  
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *  
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *  
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA
 */

#ifndef _IS1000_H

#define _IS1000_H

#include "is1000common.h"

/* 
 * Utility NOP Message
 *
 */
struct i2o_util_nop_message
{
	struct i2o_message StdMessageFrame;
};


#define MAC_ADDR_LENGTH            8

/* kinda from scsi_module.c */
int init_this_scsi_driver(void);
void exit_this_scsi_driver(void);

//version is of form A.B.c.d
static const u32 DRIVER_VERSION = 0x02001e00;

#define I2O_HBA_BUS_EXEC 0x8a

#define MAX_BUF_LIST_SIZE  (2048 + 128)
#define MAX_IOCTL_ARG_DATA (2048 + 128)

/* from iscsi firmware! */
#define MAX_TARGETS_PER_ENTITY     20
#define MAX_PORTAL_TAGS_PER_TARGET 20

#define ISCSI_ISM_NETWORK_INTERFACE_TABLE_GROUP_NO    0x8000

#define ISCSI_ISM_NETIF_TABLE_KEY_IDX                 0
#define ISCSI_ISM_NETIF_TABLE_IPADDR_IDX              3
#define ISCSI_ISM_NETIF_TABLE_SUBNET_MASK_IDX         4
#define ISCSI_ISM_NETIF_TABLE_GATEWAY_IDX             5
#define ISCSI_ISM_NETIF_TABLE_MTU_IDX                 6
#define ISCSI_ISM_NETIF_TABLE_INDEX_IDX               7
#define ISCSI_ISM_NETIF_TABLE_DHCP_IDX                8
#define ISCSI_ISM_NETIF_TABLE_CONFIG_IDX              9
#define ISCSI_ISM_NETIF_TABLE_MACADDR_IDX             10
#define ISCSI_ISM_NETIF_TABLE_EEPROM_IDX              11
#define ISCSI_ISM_NETIF_TABLE_ETHER_ID_IDX            12
#define ISCSI_ISM_NETIF_TABLE_ETHER_REV_IDX           13
#define ISCSI_ISM_NETIF_TABLE_SPEED_IDX               14
#define ISCSI_ISM_NETIF_TABLE_DUPLEX_IDX              15
#define ISCSI_ISM_NETIF_TABLE_LINK_IDX                16
#define ISCSI_ISM_NETIF_TABLE_TXPAUSED_IDX            17
#define ISCSI_ISM_NETIF_TABLE_CHIPINIT_IDX            18
#define ISCSI_ISM_NETIF_TABLE_AUTONEG_IDX             19
#define ISCSI_ISM_NETIF_TABLE_NEGMASK_IDX             20
#define ISCSI_ISM_NETIF_TABLE_FLOWCTRL_IDX            21
#define ISCSI_ISM_NETIF_TABLE_COMMIT_IDX              22

#define MII_TECH_10BASE_T	    0x0020	/* 10Base-T */
#define MII_TECH_10BASE_FD	    0x0040	/* 10Base-T Full Duplex */
#define MII_TECH_100BASE_TX	    0x0080	/* 100Base-TX */
#define MII_TECH_100BASE_TX_FD	    0x0100	/* 100Base-TX Full Duplex */
#define MII_PHY_1000T_FD	    0x10000	/* PHY may use 1000-T full duplex */

#define ALL_MII_BITS 	            0x101e0     /* all of the above */


#define ISCSI_ISM_TARGET_TABLE_GROUP_NO               0x8001

#define ISCSI_ISM_TARGET_TABLE_KEY_IDX                0
#define ISCSI_ISM_TARGET_TABLE_LUN_COUNT              5
#define ISCSI_ISM_TARGET_TABLE_STATUS_IDX             7
#define ISCSI_ISM_TARGET_TABLE_ENABLE_IDX             16

#define ISCSI_PARAM_TARGET_ENABLE                     1
#define ISCSI_PARAM_TARGET_DISABLE                    2

#define ISCSI_ISM_TARGET_SELECTOR_GROUP_NO            0x8002
#define ISCSI_ISM_TARGET_LUN_TABLE_GROUP_NO           0x8003
#define ISCSI_ISM_TARGET_SCAN_SELECTOR_GROUP_NO       0x8004
#define ISCSI_ISM_TARGET_SCAN_TABLE_GROUP_NO          0x8005

#define ISCSI_ISM_TARGET_SCAN_TABLE_ISCSI_NAME        1
#define ISCSI_ISM_TARGET_SCAN_TABLE_IP_ADDR           2
#define ISCSI_ISM_TARGET_SCAN_TABLE_PORT              3
#define ISCSI_ISM_TARGET_SCAN_TABLE_TAG               4


#define ISCSI_ISM_LUN_SCAN_SELECTOR_GROUP_NO          0x8006

#define ISCSI_ISM_TARGET_SCAN_SEL_IPADDR_IDX          0
#define ISCSI_ISM_TARGET_SCAN_SEL_PORT_IDX            1
#define ISCSI_ISM_TARGET_SCAN_SEL_START_SCAN_IDX      2
#define ISCSI_ISM_TARGET_SCAN_SEL_POLL_SCAN_IDX       3
#define ISCSI_ISM_TARGET_SCAN_SEL_CHAP_NAME_IDX       4
#define ISCSI_ISM_TARGET_SCAN_SEL_CHAP_PW_IDX         5
#define ISCSI_ISM_TARGET_SCAN_SEL_TGT_CHAP_NAME_IDX   6
#define ISCSI_ISM_TARGET_SCAN_SEL_TGT_CHAP_PW_IDX     7
#define ISCSI_ISM_TARGET_SCAN_SEL_CHAP_ENABLE_IDX     8
#define ISCSI_ISM_TARGET_SCAN_SEL_AUTH_TARGET_IDX     9

#define ISCSI_DISC_INITIATE_DISC       0x1
#define ISCSI_DISC_ABORT_DISC          0x2 

#define ISCSI_ISM_LUN_SCAN_TABLE_GROUP_NO             0x8007

#define ISCSI_DISC_STATUS_SUCCESS      0x0
#define ISCSI_DISC_STATUS_PENDING      0x1
#define ISCSI_DISC_STATUS_FAILED       0x2
#define ISCSI_DISC_STATUS_POLL         0x4
#define ISCSI_DISC_STATUS_ABORT        0x5
#define ISCSI_DISC_STATUS_MEMORY       0x6

#define ISCSI_ISM_HBA_SETTINGS_GROUP_NO               0x8008
#define ISCSI_ISM_HBA_ISCSI_STATISTICS_GROUP_NO       0x8009

#define ISCSI_ISM_HBA_SEL_NAME_IDX                    0

#define ISCSI_ISM_SESSION_TABLE_GROUP_NO              0x8010
#define ISCSI_ISM_SESSION_SELECTOR_GROUP_NO           0x8011
#define ISCSI_ISM_SESSION_NEXUS_TABLE_GROUP_NO        0x8012

#define ISCSI_ISM_BOARD_PROPERTIES_GROUP_NO           0x8013

#define ISCSI_ISM_PER_HBA_SESSION_GROUP_NO            0x8015

#define ISCSI_ISM_PER_HBA_NAME                        0
#define ISCSI_ISM_PER_HBA_RECONNECT_TIME              1
#define ISCSI_ISM_PER_HBA_MAX_RETRIES                 2
#define ISCSI_ISM_PER_HBA_CURRENT_RETRIES             3
#define ISCSI_ISM_PER_HBA_CHAP_USERNAME               4
#define ISCSI_ISM_PER_HBA_CHAP_PASSWORD               5
#define ISCSI_ISM_PER_HBA_CHAP_TGT_USERNAME           6
#define ISCSI_ISM_PER_HBA_CHAP_TGT_PASSWORD           7
#define ISCSI_ISM_PER_HBA_USE_CHAP                    8
#define ISCSI_ISM_PER_HBA_USE_INBOUND_CHAP            9
#define ISCSI_ISM_PER_HBA_IP_ADDRESS                  10
#define ISCSI_ISM_PER_HBA_PORT                        11
#define ISCSI_ISM_PER_HBA_EPHEMERAL_PORT              12
#define ISCSI_ISM_PER_HBA_SESS_CONFIG                 15
#define ISCSI_ISM_PER_HBA_ERROR_STATE                 16

#define ISCSI_ISM_EXTENDED_STATS_GROUP_NO             0x8017
#define ISCSI_ISM_EXTENDED_HBA_STATS_GROUP_NO         0x8018

#define ISCSI_ISM_ICMP_GROUP_NO                       0x8022

#define ISCSI_ISM_HOST_SPECIFIED_OPERATION_GROUP_NO   0x8014

#define ISCSI_ISM_HOST_SPECIFIC_OP_PARAM_IDX          0
#define ISCSI_ISM_HOST_SPECIFIC_OP_OPERATION_IDX      1

#define ISCSI_PARAM_BLINK_LEDS         0x01
#define ISCSI_PARAM_RESET_STATS         0x3

#define ISCSI_CHAP_FIELD_LENGTH                  255
#define ISCSI_TARGET_ADDRESS_LENGTH               16
#define ISCSI_TARGET_NAME_LENGTH                 256
#define ISCSI_INIT_NAME_LENGTH                 256
#define ISCSI_TARGET_ALIAS_LENGTH               64

#define ISCSI_ISM_LOOPBACK_GROUP_NO                   0x8023

#define ISCSI_ISM_DIAGNOSTIC_GROUP_NO         0x8026

#define ISCSI_DIAG_CARD_NOT_RESPONDING        0x40
#define ISCSI_DIAG_RESET_IN_PROGRESS          0x20

struct iscsi_adapter_private {
	int ifTableKey; /* key for accessing interface table */
	int hostAdapterNum;
	u32 shpnt;
	u32 useDhcp;
	u64 macAddr;
	u64 currentMacAddr;
         u8 init_name[ISCSI_INIT_NAME_LENGTH - 1];
};

#pragma pack (push, 1)

/* Network interface table */
typedef struct _I2O_ISCSI_NET_IF_FIELDS
{
	char           ipAddress[ISCSI_TARGET_ADDRESS_LENGTH -1];
	u32            subnetMask;
	char           gateway[ISCSI_TARGET_ADDRESS_LENGTH -1];
} I2O_ISCSI_NET_IF_FIELDS, *PI2O_ISCSI_NET_IF_FIELDS;

typedef struct _I2O_ISCSI_NET_IF_FIELDS2
{
	u32            mtu;
	u32            etherDevId;
	u32            etherRev;
	u32            linkSpeed;
	u16            duplex;
	u16            linkConn;
	u16            txPaused;
	u16            chipInit;
	u32            autoNeg;
	u32            autoNegMask;
	u32            flowControl;
} I2O_ISCSI_NET_IF_FIELDS2, *PI2O_ISCSI_NET_IF_FIELDS2;

typedef struct _I2O_ISCSI_BOARD_PROPERTIES
{
	u32            chipNum;
	u32            boardRev;
	u32            cpldRev;
	u32            processorRev;
	u32            adapFirmRev;
	u32            adapRtosRev;
} I2O_ISCSI_BOARD_PROPERTIES, *PI2O_ISCSI_BOARD_PROPERTIES;


typedef struct _I2O_TARGET_INIT_LOGIN
{
	char     key[ISCSI_TARGET_NAME_LENGTH - 1];
	char    chapUsername[ISCSI_CHAP_FIELD_LENGTH];
	char    chapPassword[ISCSI_CHAP_FIELD_LENGTH];
	char    chapTargetUsername[ISCSI_CHAP_FIELD_LENGTH];
	char    chapTargetPassword[ISCSI_CHAP_FIELD_LENGTH];
	u16     chapEnable;
	u16     chapAuthTarget;
	int     enable;
} I2O_TARGET_INIT_LOGIN, *PI2O_TARGET_INIT_LOGIN;

typedef struct
{
  char targetname[ISCSI_TARGET_NAME_LENGTH - 1];
  u32 disable;
} I20_TARGET_DISABLE, *PI20_TARGET_DISABLE;

typedef struct _I2O_ISCSI_COMMIT_IF_FIELDS
{
	u32          key;
	u32            commit;
} I2O_ISCSI_COMMIT_IF_FIELDS, PI2O_ISCSI_COMMIT_IF_FIELDS;

/* used to write to interface table */
typedef struct _I2O_ISCSI_NET_IF_ADD_FIELDS
{
	// field index 0 is the key
	u32          key;
	// field index 1 & 2 are not writable
	char           ipAddress[ISCSI_TARGET_ADDRESS_LENGTH -1];
	u32            subnetMask;
	char           gateway[ISCSI_TARGET_ADDRESS_LENGTH -1];
	u32            mtu;
	u32            index;
	u32            dhcp;
	u32            configureOnBoot;
	u64            macAddr;
	u32            linkSpeed;
	u16            duplex;
	u32            autoNeg;
	u32            autoNegMask;
	u32            flowControl;
	u32            commit;
} I2O_ISCSI_NET_IF_ADD_FIELDS, *PI2O_ISCSI_NET_IF_ADD_FIELDS;


typedef struct _I2O_ISCSI_TARGET_TABLE
{
	char    key[ISCSI_TARGET_NAME_LENGTH - 1];
	char    ipAddress[ISCSI_TARGET_ADDRESS_LENGTH -1];
	u16     port;
	u32     connectOnBoot;
	char    initName[ISCSI_INIT_NAME_LENGTH - 1];
        u32     timeout;
        u32     retries;
        u32     headerCrc;
        u32     dataCrc;
#if 0
	char    chapUsername[ISCSI_CHAP_FIELD_LENGTH];
	char    chapPassword[ISCSI_CHAP_FIELD_LENGTH];
	char    chapTargetUsername[ISCSI_CHAP_FIELD_LENGTH];
	char    chapTargetPassword[ISCSI_CHAP_FIELD_LENGTH];
	u16     chapEnable;
	u16     chapAuthTarget;
#endif
} I2O_ISCSI_TARGET_TABLE, *PI2O_ISCSI_TARGET_TABLE;


typedef struct
{
  //  char key[ISCSI_TARGET_NAME_LENGTH - 1];
  //  char alias[ISCSI_TARGET_ALIAS_LENGTH - 1];
  char ipAddress[ISCSI_TARGET_ADDRESS_LENGTH - 1];
  u16 port;
  u16 portalGroupTag;
  //  u32 lunCount;
  u32 flags;
  u32 status;
  //  u32 connectOnBoot;
  char initName[ISCSI_TARGET_NAME_LENGTH - 1];
  char chapUsername[255]; /* ? */
  char chapPassword[255];
  char chapInboundUsername[255];
  char chapInboundPassword[255];
  u16  chapEnabled;
  u16 chapInboundEnabled;
  //  u32 enable;
} ISCSI_TARGET_TABLE_FIELDS, *PISCSI_TARGET_TABLE_FIELDS;

/* The structure containing the data fresh from
 * the firmware.
 */
typedef struct
{
  char name[ISCSI_TARGET_NAME_LENGTH - 1];
  char ipAddress[ISCSI_TARGET_ADDRESS_LENGTH - 1];
  u32  port;
  u32  tag;
} ISCSI_ENUM_TARGETS, *PISCSI_ENUM_TARGETS;

/* The structure for a single target's data.
 * Note: includes space for max portals per target.
 * Note: total buffer is this struct * max targets
 *       allowed per entity(MAX_TARGETS_PER_ENTITY).
 */
typedef struct
{
  char iscsi_nodename[ISCSI_TARGET_NAME_LENGTH];
  u32  numAddresses;
  IS_TARGET_ADDRESS addresses[MAX_PORTAL_TAGS_PER_TARGET];
} ISCSI_TOTAL_ENUM_TARGETS, *PISCSI_TOTAL_ENUM_TARGETS;

typedef struct 
{
    u32    initialR2t;                     /* TRUE indicates =yes */
    u32    immediateData;
    u32     firstBurstLength;
    u32     maxBurstLength;
    u32     maxConnections;
    u32     headerDigest;                   /* TRUE indicates yes */
    u32     dataDigest;
    u32     isidQualifier;                  /* Only bottom 16 bits valid */
    u32     tsid;                           /* ditto */
    u32     connectionId;                   /* CID */
    u32     targetPortalGroup;
} ISCSI_ISM_SESSION_CONFIG, *PISCSI_ISM_SESSION_CONFIG;


#pragma pack (pop)

extern u32 is1000_find_host_no(struct i2o_controller *c, int *host_no);
void is1000EventHandler(struct i2o_handler *pI2oHandler, 
			struct i2o_controller * pI2oController,
			struct i2o_message *pMsg);

uint inet_addr(register char *inetString);

#define CHAR_FROM_CONST(x)          (char *)(x)
#define EOS                         '\0'
#define ERROR                       -1

#define _C_UPPER         0x1
#define _C_LOWER         0x2
#define _C_NUMBER        0x4
#define _C_WHITE_SPACE   0x8
#define _C_PUNCT         0x10
#define _C_CONTROL       0x20
#define _C_HEX_NUMBER    0x40
#define _C_B             0x80

#ifndef ULONG_MAX
#ifdef __STDC__
#define ULONG_MAX			4294967295u
#else
#define ULONG_MAX			4294967295
#endif
#endif

static const unsigned char __ctype_tab[257] =
{
	/* 0 */     0,              /* dummy */
	/* 80 */    _C_B,               /* nul */
	/* 80 */    _C_B,               /* soh */
	/* 80 */    _C_B,               /* stx */
	/* 80 */    _C_B,               /* etx */
	/* 80 */    _C_B,               /* eot */
	/* 80 */    _C_B,               /* enq */
	/* 80 */    _C_B,               /* ack */
	/* 80 */    _C_B,               /* bel */
	/* 80 */    _C_B,               /* bs */
	/* 20 */    _C_CONTROL,         /* ht */
	/* 20 */    _C_CONTROL,         /* nl */
	/* 20 */    _C_CONTROL,         /* vt */
	/* 20 */    _C_CONTROL,         /* np */
	/* 20 */    _C_CONTROL,         /* cr */
	/* 80 */    _C_B,               /* so */
	/* 80 */    _C_B,               /* si */
	/* 80 */    _C_B,               /* dle */
	/* 80 */    _C_B,               /* dc1 */
	/* 80 */    _C_B,               /* dc2 */
	/* 80 */    _C_B,               /* dc3 */
	/* 80 */    _C_B,               /* dc4 */
	/* 80 */    _C_B,               /* nak */
	/* 80 */    _C_B,               /* syn */
	/* 80 */    _C_B,               /* etb */
	/* 80 */    _C_B,               /* can */
	/* 80 */    _C_B,               /* em */
	/* 80 */    _C_B,               /* sub */
	/* 80 */    _C_B,               /* esc */
	/* 80 */    _C_B,               /* fs */
	/* 80 */    _C_B,               /* gs */
	/* 80 */    _C_B,               /* rs */
	/* 80 */    _C_B,               /* us */
	/* 08 */    _C_WHITE_SPACE,     /* space */
	/* 10 */    _C_PUNCT,           /* ! */
	/* 10 */    _C_PUNCT,           /* " */
	/* 10 */    _C_PUNCT,           /* # */
	/* 10 */    _C_PUNCT,           /* $ */
	/* 10 */    _C_PUNCT,           /* % */
	/* 10 */    _C_PUNCT,           /* & */
	/* 10 */    _C_PUNCT,           /* ' */
	/* 10 */    _C_PUNCT,           /* ( */
	/* 10 */    _C_PUNCT,           /* ) */
	/* 10 */    _C_PUNCT,           /* * */
	/* 10 */    _C_PUNCT,           /* + */
	/* 10 */    _C_PUNCT,           /* , */
	/* 10 */    _C_PUNCT,           /* - */
	/* 10 */    _C_PUNCT,           /* . */
	/* 10 */    _C_PUNCT,           /* / */
	/* 44 */    _C_NUMBER | _C_HEX_NUMBER,  /* 0 */
	/* 44 */    _C_NUMBER | _C_HEX_NUMBER,  /* 1 */
	/* 44 */    _C_NUMBER | _C_HEX_NUMBER,  /* 2 */
	/* 44 */    _C_NUMBER | _C_HEX_NUMBER,  /* 3 */
	/* 44 */    _C_NUMBER | _C_HEX_NUMBER,  /* 4 */
	/* 44 */    _C_NUMBER | _C_HEX_NUMBER,  /* 5 */
	/* 44 */    _C_NUMBER | _C_HEX_NUMBER,  /* 6 */
	/* 44 */    _C_NUMBER | _C_HEX_NUMBER,  /* 7 */
	/* 44 */    _C_NUMBER | _C_HEX_NUMBER,  /* 8 */
	/* 44 */    _C_NUMBER | _C_HEX_NUMBER,  /* 9 */
	/* 10 */    _C_PUNCT,           /* : */
	/* 10 */    _C_PUNCT,           /* ; */
	/* 10 */    _C_PUNCT,           /* < */
	/* 10 */    _C_PUNCT,           /* = */
	/* 10 */    _C_PUNCT,           /* > */
	/* 10 */    _C_PUNCT,           /* ? */
	/* 10 */    _C_PUNCT,           /* @ */
	/* 41 */    _C_UPPER | _C_HEX_NUMBER,   /* A */
	/* 41 */    _C_UPPER | _C_HEX_NUMBER,   /* B */
	/* 41 */    _C_UPPER | _C_HEX_NUMBER,   /* C */
	/* 41 */    _C_UPPER | _C_HEX_NUMBER,   /* D */
	/* 41 */    _C_UPPER | _C_HEX_NUMBER,   /* E */
	/* 41 */    _C_UPPER | _C_HEX_NUMBER,   /* F */
	/* 01 */    _C_UPPER,           /* G */
	/* 01 */    _C_UPPER,           /* H */
	/* 01 */    _C_UPPER,           /* I */
	/* 01 */    _C_UPPER,           /* J */
	/* 01 */    _C_UPPER,           /* K */
	/* 01 */    _C_UPPER,           /* L */
	/* 01 */    _C_UPPER,           /* M */
	/* 01 */    _C_UPPER,           /* N */
	/* 01 */    _C_UPPER,           /* O */
	/* 01 */    _C_UPPER,           /* P */
	/* 01 */    _C_UPPER,           /* Q */
	/* 01 */    _C_UPPER,           /* R */
	/* 01 */    _C_UPPER,           /* S */
	/* 01 */    _C_UPPER,           /* T */
	/* 01 */    _C_UPPER,           /* U */
	/* 01 */    _C_UPPER,           /* V */
	/* 01 */    _C_UPPER,           /* W */
	/* 01 */    _C_UPPER,           /* X */
	/* 01 */    _C_UPPER,           /* Y */
	/* 01 */    _C_UPPER,           /* Z */
	/* 10 */    _C_PUNCT,           /* [ */
	/* 10 */    _C_PUNCT,           /* \ */
	/* 10 */    _C_PUNCT,           /* ] */
	/* 10 */    _C_PUNCT,           /* ^ */
	/* 10 */    _C_PUNCT,           /* _ */
	/* 10 */    _C_PUNCT,           /* ` */
	/* 42 */    _C_LOWER | _C_HEX_NUMBER,   /* a */
	/* 42 */    _C_LOWER | _C_HEX_NUMBER,   /* b */
	/* 42 */    _C_LOWER | _C_HEX_NUMBER,   /* c */
	/* 42 */    _C_LOWER | _C_HEX_NUMBER,   /* d */
	/* 42 */    _C_LOWER | _C_HEX_NUMBER,   /* e */
	/* 42 */    _C_LOWER | _C_HEX_NUMBER,   /* f */
	/* 02 */    _C_LOWER,           /* g */
	/* 02 */    _C_LOWER,           /* h */
	/* 02 */    _C_LOWER,           /* i */
	/* 02 */    _C_LOWER,           /* j */
	/* 02 */    _C_LOWER,           /* k */
	/* 02 */    _C_LOWER,           /* l */
	/* 02 */    _C_LOWER,           /* m */
	/* 02 */    _C_LOWER,           /* n */
	/* 02 */    _C_LOWER,           /* o */
	/* 02 */    _C_LOWER,           /* p */
	/* 02 */    _C_LOWER,           /* q */
	/* 02 */    _C_LOWER,           /* r */
	/* 02 */    _C_LOWER,           /* s */
	/* 02 */    _C_LOWER,           /* t */
	/* 02 */    _C_LOWER,           /* u */
	/* 02 */    _C_LOWER,           /* v */
	/* 02 */    _C_LOWER,           /* w */
	/* 02 */    _C_LOWER,           /* x */
	/* 02 */    _C_LOWER,           /* y */
	/* 02 */    _C_LOWER,           /* z */
	/* 10 */    _C_PUNCT,           /* { */
	/* 10 */    _C_PUNCT,           /* | */
	/* 10 */    _C_PUNCT,           /* } */
	/* 10 */    _C_PUNCT,           /* ~ */
	/* 80 */    _C_B                /* del */
};  

#define wrs_htonl(x)      (x)

uint wrs_strtoul(const char *nptr, char **endptr, int base);

#define IOP_MAXIMUM_TARGETS 128

/* possible target status */
#define ISCSI_TARGET_STATUS_CONNECTED  0
#define ISCSI_TARGET_STATUS_FAILED     1
#define ISCSI_TARGET_STATUS_FAULTED    2

/* State Change event status */
#define ISCSI_ISM_NET_LINK_DOWN          0xE0
#define ISCSI_ISM_NET_LINK_UP            0xE1
#define ISCSI_ISM_NET_DHCP_LEASE_NEW     0xE2
#define ISCSI_ISM_NET_DHCP_LEASE_EXPIRE  0xE3
#define ISCSI_ISM_NET_DHCP_BIND_FAIL     0xE4
#define ISCSI_ISM_LOGIN_REDIR_PERM       0xEE
#define ISCSI_ISM_ERROR_EVENT            0xFA

typedef struct {
  char name[ISCSI_TARGET_NAME_LENGTH];
  int  tid;
  int  index;
  int  status;
} ISCSI_TID_DATA, *PISCSI_TID_DATA;

typedef struct {
  PISCSI_TID_DATA pTidData;
  int inUse;
} ISCSI_TASK_DATA, *PISCSI_TASK_DATA;

/* this is in is1000common.h - but is1000_scsi.c needs it too now! */
#define IS_TARGETID_INVALID               255

struct i2o_scsi_host
{
        struct i2o_controller *controller;
        ISCSI_TASK_DATA aTaskData[IOP_MAXIMUM_TARGETS];
        ISCSI_TID_DATA aTidData[IOP_MAXIMUM_TARGETS];
	unsigned long tagclock[IOP_MAXIMUM_TARGETS];
	s16 bus_task;		/* The adapter TID */
};

// frame size in words
#define  MSG_FRAME_SIZE		64

// use from i2o.h ?
#define NMBR_MSG_FRAMES	128

// total size of msg pool in bytes
#define MSG_POOL_SIZE	       (NMBR_MSG_FRAMES*MSG_FRAME_SIZE*sizeof(u32))


#endif /* _IS1000_H */
