#
# Spec file for Intel PRO/1000 T Storage Adapter
#
Summary: Intel PRO/1000 T IP Storage Adapter
Name: is1000
Version: 2.0
Release: RPMVERSION
Group: System Environment/Kernel
Source: %{name}-%{version}.tgz
Copyright: GPL
Vendor: Intel Corporation
Packager: Intel Corporation

%description
The Intel PRO/1000 T IP Storage Adapter: an intelligent Storage Area Networking iSCSI Host Bus Adapter.

%prep
%setup

%build
make all-nodriver

%install
make install-nodriver
cp -f $RPM_SOURCE_DIR/%{name}-%{version}.tgz /usr/share/%{name}-%{version}

# Files that are part of the package
#
%files
%defattr(0444,root,root)
%doc install/README.txt
%doc install/README.OpenSLP
%doc install/README.scsidev
/usr/share/%{name}-%{version}/drivers
/usr/share/%{name}-%{version}/%{name}-%{version}.tgz
%attr(0700,root,root) /etc/rc.d/init.d/is1000
%attr(0700,root,root) /usr/sbin/isiconfig
%attr(0700,root,root) /usr/sbin/isdaemon
%attr(0700,root,root) /usr/sbin/is1000-mountall
%attr(0700,root,root) /usr/sbin/add-iscsi-targets
%attr(0700,root,root) /usr/sbin/find-iscsi-targets
%attr(0700,root,root) /usr/lib/libinteliscsi.so

%pre
if [ $1 -ge 2 ]; then
	lsmod | grep "is1000" > /dev/null 2>&1
	if [ $? -eq 0 ]; then
		echo "Previous installation detected.  Stopping is1000 service."
		service is1000 stop
		if [ $? -ne 0 ]; then
			echo "Unable to stop is1000 service.  Upgrade aborted."
			return 1
		fi
	fi
fi

# make sure the verfile.tic is present.
VERFILE=/mnt/cdrom/verfile.tic

if [ -s $VERFILE ] ; then
	mkdir -p /usr/share/%{name}-%{version}; cp -f $VERFILE /usr/share/%{name}-%{version}

	FILEEXT=`date +"%F.%H%M%S"`
	if [ ! -e /etc/is1000.conf ] ; then
		echo "[GLOBALSETTINGS]" > /etc/is1000.conf
		echo "TICFILE=/usr/share/%{name}-%{version}/verfile.tic" >> /etc/is1000.conf
		chmod 600 /etc/is1000.conf
	fi

else
	echo "Unable to find $VERFILE.  Please make sure that the Intel PRO/1000 T IP Storage Adapter CDROM"
	echo "is mounted at /mnt/cdrom or contact Intel technical support."
	exit -1
fi

%post
chkconfig --add is1000
chkconfig is1000 on
ldconfig
depmod -a
service is1000 start

%preun
if [ $1 -eq 0 ]; then
	lsmod | grep "is1000" > /dev/null 2>&1
	if [ $? -eq 0 ]; then
		service is1000 stop
	fi
	chkconfig --del is1000
fi

%postun
if [ $1 -eq 0 ]; then
	ldconfig
	depmod -a
	rm -rf /dev/is1000devs
	rm -f /dev/is1000
    rm -rf /usr/share/%{name}-%{version}
fi

