/*******************************************************************************
* Copyright (C) 2002-2003 Intel Corporation                                    *
*                                                                              *
* This program is free software; you can redistribute it and/or                *
* modify it under the terms of the GNU General Public License                  *
* as published by the Free Software Foundation; either version 2               *
* of the License, or (at your option) any later version.                       *
*                                                                              *
* This program is distributed in the hope that it will be useful,              *
* but WITHOUT ANY WARRANTY; without even the implied warranty of               *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                *
* GNU General Public License for more details.                                 *
*                                                                              *
* You should have received a copy of the GNU General Public License            *
* along with this program; if not, write to the Free Software                  *
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA   *
*******************************************************************************/
/*******************************************************************************
*                                                                              *
* File Name:    utility.h                                                      *
*                                                                              *
* Abstract:     This module provides the interface to the utility functions    *
*               that isiconfig uses.                                           *
*                                                                              *
* Environment:  This file should be used only by the isiconfig internals.      *
*                                                                              *
* Author:       Thomas C. Lea                                                  *
*                                                                              *
* Origination:  April 21, 2003                                                 *
*                                                                              *
* Modification History                                                         *
* Date     Initials   Description                                              *
* 04/21/03 TCL        Genesis                                                  *
*******************************************************************************/

#ifndef __UTILITY_H__
#define __UTILITY_H__

#include <string>
#include "is1000api.h"

std::string mactostring(const IS_MAC_ADDRESS &MacAddr);
bool stringtomac(const std::string, IS_MAC_ADDRESS &mac);
std::string iptostring(const IP_TYPE &ip);
bool stringtoip(const std::string, IP_TYPE &ip);
IS_RESULT getAdapterMac(u32 index, IS_MAC_ADDRESS &mac);
void showVersion();
void showDetails(int adapternumber, IS_MAC_ADDRESS &mac);
void updateDeviceHive();
void dumpLoginStats(IS_LOGIN_STATS &stats);
void dumpInitiatorStats(IS_INITIATOR_STATS &stats);
void dumpNicStats(IS_NIC_STATS &stats);
void dumpConnectionStats(IS_CONNECTION_STATS &stats);
void dumpExtSessionStats(IS_EXT_SESSION_STATS &stats);
bool isTargetMounted(IS_MAC_ADDRESS *mac, IP_TYPE &ip, int port, char *targetname);

#define MAX_RESULT_STRING_LENGTH 128

extern char errorStrings[IS_RESULT_CODE_COUNT][MAX_RESULT_STRING_LENGTH];

#define RESULTSTRING(x) ((x>0||x<-27)?"INVALID RESULT CODE":errorStrings[-x])
#endif //__UTILITY_H_
